#ifndef _CONTOUR_HEADER_INCLUDE_
#define _CONTOUR_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include "Image.h"
#include "Vector.h"

#define CONTOUR_GRADIENT_MAX_RADIUS 256

using namespace std;
using namespace cv;

bool processEvents();

double contourLaplacian(IplImage *image, int x, int y);

Vector2D contourLaplacianDifference(IplImage *image, int x, int y);

Vector2D contourIsotopeGradient(IplImage *image, int x, int y);

double contourSlopeLimitedNorm(IplImage *image, int x, int y, double bn);

void contourInpaint( IplImage *image, IplImage *mask, IplImage *dst, double dT = 0.01, int iter = 100 );

#endif