#ifndef _EXEMPLAR_HEADER_INCLUDE_
#define _EXEMPLAR_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include "Image.h"
#include "Vector.h"

using namespace std;
using namespace cv;

#define EXMP_ISOTOPE_AVG_THRESHOLD 0.4
#define EXMP_DATAPOINT_ALPHA 255.0
#define EXMP_DATAPOINT_NORMAL_WINDOWSIZE 4
#define EXMP_GRADIENT_MAX_RADIUS 2

#define EXMP_METHOD 0
#define LOCAL_METHOD 1

bool processEvents();
void windowUpdate();

IplImage* exmpExtractPatch(IplImage *img, int r, int c, int size);

void exmpBorderFront(IplImage *msk, vector< pair<int, int> >& borderPixels);

void exmpListSourcePatches(IplImage *msk, vector< pair<int, int> >& sourcePatches, 
                           int patchSize, int stepSize = 1);

double exmpGetPatchDistance( IplImage *img, IplImage *msk, int x1, int y1, int x2, int y2, int patchSize,
                             double earlyExit = -1.0, double *result = NULL);

void exmpFillPatch( IplImage *img, IplImage *msk, int sx, int sy, int dx, int dy, int patchSize );

void exmpUpdateConfidence( IplImage *img, IplImage *msk, IplImage *cp, int x, int y, int patchSize );

Vector2D exmpGradient( IplImage *image, IplImage *mask, int x, int y );

double exmpCalculateDatapoint( IplImage *img, IplImage *msk, int x, int y, 
                          int windowSize, int patchSize );

double exmpCalculatePriority( IplImage *img, IplImage *msk, IplImage *cp, int x, int y, int patchSize,
                              double *result = NULL);

void exmpInitializePriority( IplImage *img, IplImage *msk, IplImage *cp );

void exmpSourceMask( IplImage *imsk, IplImage *smsk, int dis );

void exmpInPaint(IplImage *img, IplImage *msk, int iter = 500, int patchSize = 4, 
                 int boundary = 20, int skip = 1, int method = EXMP_METHOD, bool GPU = false);


#endif
