#ifndef _WIN32_GUI_WRAPPER_HEADER_
#define _WIN32_GUI_WRAPPER_HEADER_

#define MAX_BUFFER_SIZE 10240

#include <cstdio>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string>

using namespace std;

extern HINSTANCE hinst;

HWND UIButton(char *Caption, int x, int y, int w, int h, int ID, HWND Parent);
HWND UIWindow(char *Name, LPCTSTR classname, int x, int y, int w, int h, HWND Parent, int ID = 0, bool Border = 0);
HWND UIForm(char *Name, LPCTSTR classname, int x, int y, int w, int h, HWND Parent, int ID);
HWND UILabel(char *Caption, int x, int y, int w, int h, int ID, HWND Parent);
HWND UIComboBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent);
HWND UIEdit(char *Caption, int x, int y, int w, int h, int ID, HWND Parent, bool Multi=0, bool ReadOnly = 0);
HWND UIListBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent);
HWND UIGroupBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent);
HWND UITrackBar(int x, int y, int w, int h, int ID, HWND Parent, int mn, int mx, int init, int skip = 1);
HWND UICheckBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent, bool State = false);
void UIAddCombo(char* Caption, HWND Handle, int OptNum);
void UIResetCombo(HWND Handle);
void UISelCombo(HWND Handle, int Sel);
int  UIGetSelCombo(HWND Handle);
void UIAddList(char* Caption, HWND Handle);
int  UIGetListSel(HWND Handle, int Index);
void UIResetList(HWND Handle);
void UIGetText(HWND Handle, char* Dest, int Len = MAX_BUFFER_SIZE);
void UISetText(HWND Handle, char* Text);
void UIGetEditText(char* Dest, HWND Handle, int Len = MAX_BUFFER_SIZE, int Line=0);
void UISetEditText(const char *Text, HWND Handle);
void UIPrintf(HDC hDC, int x, int y, const char *fmt, ...);
void UIEditScroll(HWND Handle, int Type = 0);
int  UIGetTrackBar(HWND Handle);
void UISetTrackBar(HWND Handle, int Value);
void UISetRange(HWND Handle, int mn, int mx);
void UISetTextPrintf(HWND Handle, const char *fmt, ...);
void UISetEditTextPrintf(HWND Handle, const char *fmt, ...);
bool UIGetCheckBox( HWND Handle );
RECT UIRect(int x, int y, int r, int b);
OPENFILENAME UIGetOFN(char *file, char *filter, char *ext, HWND owner = NULL, string initialDir = "");

#endif