#ifndef _TOOLBAR_HEADER_INCLUDE _
#define _TOOLBAR_HEADER_INCLUDE _

#include <cstring>
#include <string>
#include <windows.h>
#include "Inpaint.h"
#include "Interface.h"
#include "Mask.h"

using namespace std;

#define WINDOW_TITLE "Inpainter v1.0"
#define STATE_FREE 0
#define STATE_RUN 1


#define NUM_ALGO_OPTIONS 7
extern char comboAlgorithmOptions[][64];
#define NUM_SEP_OPTIONS 4
extern char comboSeparationOptions[][64];

extern bool programQuit;
extern int programState;
extern Inpainter globalInpainter;
extern bool programMaskEdit;

// --> Enums 

typedef enum {
    ID_IMGPATH_EDIT = 100,
    ID_MSKPATH_EDIT,
    ID_OUTPATH_EDIT,
    ID_IMGPATH_BUTTON,
    ID_MSKPATH_BUTTON,
    ID_OUTPATH_BUTTON,
    ID_ALG_COMBO,
    ID_SEP_COMBO,
    ID_MASK_CHECK,
    ID_SAVE_CHECK,
    ID_HELP_CHECK,
    ID_RUN_BUTTON,
    ID_RESET_BUTTON
} enum_widget_ids;

typedef enum {
    ID_GAUSSIAN_OCTAVES_TRACKBAR = 1100,
    ID_FDII_KERNEL_COMBO,
    ID_FDII_ITER_TRACKBAR,
    ID_BERTALMIO_INPSTEPS_TRACKBAR,
    ID_BERTALMIO_DIFSTEPS_TRACKBAR,
    ID_BERTALMIO_CR_EDIT,
    ID_BERTALMIO_CRD_EDIT,
    ID_TELEA_TRACKBAR,
    ID_NAVIER_TRACKBAR,
    ID_EXMP_ITER_TRACKBAR,
    ID_EXMP_PTCH_TRACKBAR,
    ID_EXMP_BDRY_TRACKBAR,
    ID_EXP_GPU_CHECK
} enum_param_widget_ids;

// --> Variables

extern HWND hToolbarForm;
extern HWND hImgPathEdit;
extern HWND hOutPathEdit;
extern HWND hMskPathEdit;
extern HWND hImgPathButton;
extern HWND hMskPathButton;
extern HWND hOutPathButton;
extern HWND hAlgSelectCombo;
extern HWND hSepSelectCombo;
extern HWND hParamWindow[NUM_ALGO_OPTIONS];
extern HWND hMaskEditCheck;
extern HWND hSaveImgCheck;
extern HWND hHelpShowCheck;
extern HWND hRunButton;
extern HWND hResetButton;
extern HWND hHelpWindow;
extern HWND hMaskEditWindow;

extern HWND hGaussianOctavesLabel;
extern HWND hGaussianOctavesTrackbar;
extern HWND hFDIIKernelLabel;
extern HWND hFDIIKernelCombo;
extern HWND hFDIIIterLabel;
extern HWND hFDIIIterTrackbar;
extern HWND hBertalmioInpaintStepsLabel;
extern HWND hBertalmioInpaintStepsTrackbar;
extern HWND hBertalmioDiffuseStepsLabel;
extern HWND hBertalmioDiffuseStepsTrackbar;
extern HWND hBertalmioClimbRateLabel;
extern HWND hBertalmioClimbRateEdit;
extern HWND hBertalmioClimbRateDecayLabel;
extern HWND hBertalmioClimbRateDecayEdit;
extern HWND hTeleaRadiusLabel;
extern HWND hTeleaRadiusTrackbar;
extern HWND hNavierRadiusLabel;
extern HWND hNavierRadiusTrackbar;
extern HWND hExmpIterLabel;
extern HWND hExmpIterTrackbar;
extern HWND hExmpPatchSizeLabel;
extern HWND hExmpPatchSizeTrackbar;
extern HWND hExmpBoundaryLabel;
extern HWND hExmpBoundaryTrackbar;
extern HWND hExmpGPUCheck;

extern string windowLastInputFolder;
extern string windowImagePath;
extern string windowMaskPath;
extern string windowOutputPath;

extern int windowSelectedAlgorithm;
extern int windowSelectedSeparation;
extern int windowSaveInterim;

// --> Functions

void windowError(char *msg, int value = 0);
void windowParametersSwitchAlgorithm();
double windowGetEditDouble( HWND h, double defaultVal = 0.0 );
void windowSetupParameters();
void windowSetup(HINSTANCE hThisInstance);
bool windowOpenFileDialog( char *dest);
bool windowSaveFileDialog( char *dest);
void windowUpdateResult();
void windowLoadImageMask();
void windowPrepareInpaint();
void windowChangeProgramState( int newState );
void windowHelpMessage( const char* msg );
void windowUpdate();



LRESULT CALLBACK windowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

#endif